/*
 *	lcd5.h - LCDCgvO
 *
 *	Copyright (C) 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *
 *	* Tue May 28 21:12:00 JST 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33208.h"
#include "pcekn_sym.h"

#define plc_IO ((volatile struct c_IOtag*)0x40000) /* c33208.hp */

int call(int addr);
void pdwait(int n);
void lcd_init();
void lcd_off();
void lcd_on();

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* z */

/****************************************************************************
 *	pceApp`֐
 ****************************************************************************/

void
pceAppInit()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceLCDDispStart();

	/* ŏɉʂāA]Ă܂B
	 * vOł́Aʓ]͍s܂B
	 */
	memset(vbuff, 2, sizeof vbuff);
	pceLCDLine(1,          0,          0, DISP_X    , DISP_Y    );
	pceLCDLine(1, DISP_X    ,          0,          0, DISP_Y    );
	pceLCDLine(3, DISP_X / 2,          0, DISP_X    , DISP_Y / 2);
	pceLCDLine(3, DISP_X    , DISP_Y / 2, DISP_X / 2, DISP_Y    );
	pceLCDLine(3, DISP_X / 2, DISP_Y    ,          0, DISP_Y / 2);
	pceLCDLine(3,          0, DISP_Y / 2, DISP_X / 2,          0);
	pceLCDTrans();

	/* LCDC𑀍삷邽߂̏s܂B */
	lcd_init();
}

void
pceAppProc(int count)
{
	int pad;

	/* ͂ǂ݂܂B */
	pad = pcePadGet();

	/* SELECT{^ꂽAI܂B */
	if(pad & TRG_SELECT) { pceAppReqExit(0); return; }

	/* A{^ꂽAʂ܂B */
	if(pad & TRG_A) lcd_off();

	/* B{^ꂽAʂ\܂B */
	if(pad & TRG_B) lcd_on();
}

void
pceAppExit()
{
	/* LCDC֘A̐ݒύX̂ŁASɍď܂B */
	call(pcekn_InitLCD);
}

/****************************************************************************
 *	̑̊֐
 ****************************************************************************/

/* J[l̊֐𒼐ڌĂяo܂B
 * [in]
 *	addr		J[l̊֐AhXB
 * [out]
 *	߂l		J[l̊֐̖߂lB
 */
int
call(int addr)
{
	asm("call %r12");
}

/* EFCg֐ł(critical.c)B
 */
void
pdwait(int n)
{
	asm("
		xld.w	%r13, 0x1000000
		ld.w	%r14, %r13
		mac	%r12
	");
}

/* LCDC𒼐ڑ삷邽߂̏s܂B
 */
void
lcd_init()
{
	volatile unsigned char* bp = (volatile unsigned char*)plc_IO;
DISABLE;
	/* 0x402d7
	 *    bit3: #SRDY3/P32 -> 0:P32(LCD CSB ̖߂) ... ύX
	 *    bit2: #SCLK3/P15 -> 0:P15(LCD SCLK      ) ... ύX
	 *    bit1: SOUT3 /P16 -> 0:P16(LCD SID       ) ... ύX
	 *    bit0: SIN3  /P33 -> 0:P33(LCD RESETB    ) ... ̂܂
	 * c33208.hɂ͂ȂVACh.2,3ɊւLq܂B
	 *   Ch.2,3́AS1C33208209̎ɑ݂ꂽ̂m܂B
	 *   dȂ̂ŁAAhX𒼐ڎw肵܂B
	 * IOC15,16,32,33̓o͐ݒ͕K{łI
	 *   J[lIOC15,16,32,33̓o͐ݒsĂ悤Ɍ̂łA
	 *   ȂAłxIOC15,16,32,33̓o͐ݒsȂƁA
	 *   `bvZNgr[ɊԈf[^MĂ܂܂B
	 *   ̒[qVARg[ƂĎgƁA
	 *   o͐ݒ肪ɂȂĂ܂̂ł傤HiTODO:vj
	 */
	bp[0x2d7] = 0x00;   /* [q̗prݒ   */
	bP3_IOC3_IOC32 = 0; /* CSB̖߂ -> IN  */
	bP1_IOC1_IOC15 = 1; /* SCLK      -> OUT */
	bP1_IOC1_IOC16 = 1; /* SID       -> OUT */
	bP3_IOC3_IOC33 = 1; /* RESETB    -> OUT */

	/* P20(LCD CSB) -> LOW ... LCDC͏Ƀ`bvZNgԂƂ܂B */
	bP2_P2D_P20D = 0;
ENABLE;
}

/* LCDC1oCgM܂B
 * [in]
 *	rs		WX^I(0:R}h/1:f[^)B
 *	value		MlB
 */
void
lcd_write(int rs, unsigned char value)
{
	int i;

	/* LCDCWX^I(0:R}h/1:f[^)B
	 * ۂɂ́AŌ̃rbg(bit0)TvO鎞AK؂ȑIԂɂȂĂΏ[łB
	 * (S6B0741 f[^V[g)
	 */
	bP2_P2D_P21D = rs ? 1 : 0;

	/* rbg70̏őM܂B
	 * LCDĆASCLKM̗オŁATvOs܂B
	 * 1
	 *   ɃEFCgKv͂܂B
	 *   S6B0741̃f[^V[g(66y[W)ɂƁASPIڑE2.7VȏŎgꍇA
	 *   S6B0741͖17MHz܂łSCLKɂĂ܂B
	 *   for̒̊es1NbNŎsꂽƂĂ(肦܂)A
	 *   24Mhz38MHzx̓]xo܂B
	 *   āAEFCgKv͂܂B
	 *   ]xłȂAeMHI/LOWێȂ΂ȂԂK肳Ă܂A
	 *   ̎Ԃ[ɏĂ̂ŁAEFCgȂĂvłB
	 *   ڂ́Af[^V[gQƂĂB
	 */
	for(i = 0; i < 8; i++, value <<= 1) {
		bP1_P1D_P15D = 0;
		/* 1 */
		bP1_P1D_P16D = value & 0x80 ? 1 : 0;
		/* 1 */
		bP1_P1D_P15D = 1; /* LCDCSID(P16)TvO܂B */
		/* 1 */
	}
}

/* ʂ܂B
 */
void
lcd_off()
{
	lcd_write(0, 0xae + 0); /* Display ON/OFF (bit0=0:OFF) */
}

/* ʂ\܂B
 */
void
lcd_on()
{
	lcd_write(0, 0xae + 1); /* Display ON/OFF (bit0=1:ON) */
}
